Java中try/catch执行时机

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/dreamwbt/article/details/76585230

简介

学习Java这么久以来,我一直以为在try中出现了异常,那么会通过catch捕获,并且后边的代码不再执行,但是今天发现catch之后后边(其实“后边”用的不恰当,后文会解释)的代码仍旧在执行。

示例代码

public class Threadtest {
	public static void main(String[] args) {
		Threadtest threadtest = new Threadtest();
			try {
				threadtest.testa();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			System.out.println("我是异常之后的diamante");
	}

	public void testa() throws IOException {
		throw new IOException();
	}
}

执行结果


图A

意外发现

上边的执行结果是比较常见的,我在第一次执行的时候结果其实不是这样的而是类似于图B,但是这种结果很难再现,然后我用了循环试了一下,出现过一次,如图C,很显然,让一个异常之后的文字输出在第二次异常之后才输出,我的判断结论是,当try中出现了异常,Java会自动创建一个线程执行catch当中的数据。

图B



图C

补充:

之前说当try中有异常的时候,Java会自动创建一个线程执行catch当中的代码,后来发现不是这么回事,而是在调用异常信息(“e.printStackTrace();”)的时候会通过单独的线程来输出,这个从性能的角度是比较好的,不让业务以外的东西影响业务。


展开阅读全文

没有更多推荐了,返回首页